/* Buffered IO Module
   Scott M. Baker, 1998
*/

#ifndef BUFFER_H
#define BUFFER_H

typedef struct Buffer *pBuffer;

struct Buffer {
  char CurChar;
  char *BufStart;
  char *BufPtr;
  char *LineStart;
  char *LinePtr;
  int Timeout;
  int Remain;
  int Size;
  int OutFile;
  int IsEof;
  int File;
  int HadTimeout;
  int Abort;
  SOCKET Sock;
  SOCKET OutSocket;

  int TotalBytes;

  char *Html_dbuff;
  char *Html_dstart;
  char *Html_dend;
  int Html_CurToken, Html_LastToken;
  int Html_CurTok_Negate;
  int Html_Preform;
  int Html_allocdbuff;
  int Http_PastHeader;

  void (/*__cdecl*/ *Callback)(pBuffer buffer);
  void *UserData;

  char NfsHandle[64];
  int UseNfsHandle;
  int Gecko2Eof;
};

#define BufferHaveChar(buf) (((buf->Remain<=0) && (!BufferFill(buf))) ? FALSE : TRUE)
#define BufferConsumeChar(buf) buf->Remain--; buf->CurChar = *(buf->BufPtr++);
//#define BufferGetChar(buf) (((buf->Remain<=0) && (!BufferFill(buf))) ? FALSE : (buf->Remain--, buf->CurChar = *(buf->BufPtr++)), TRUE)
//#define BufferGetChar(buf) (((buf->Remain<=0) && (!BufferFill(buf))) ? FALSE : BufferGetChar1(buf))

#ifdef __CPLUSPLUS__
extern "C" {
#endif

void BufferDump(struct Buffer *buf);
int BufferGetChar(struct Buffer *buf);
int BufferGetLine(struct Buffer *buf);
struct Buffer *BufferCreate(void);
void BufferDrainConnection(struct Buffer *buf);
void BufferReset(struct Buffer *buf);
void BufferFree(struct Buffer *buf);
void BufferToBeginning(struct Buffer *buf);
int BufferFill(struct Buffer *buf);

#ifdef __CPLUSPLUS__
}
#endif

#endif
