#ifndef DIRCACHE_H
#define DIRCACHE_H

#include "handle.h"

#ifdef WINDOWS
#include "d:\bc\projects\proxy\hash\Hash.h"
#include "nfsfake.h"
#else
#include "hash.h"
#include "nfs.h"
#endif

#define DIR_FLAG_CONSIST 1
#define DIR_FLAG_HASCONTENTS 2
#define DIR_FLAG_HASHEADERS 4
#define DIR_FLAG_HASDOTROOT 8
#define DIR_FLAG_HASINFO 16

#define DIR_FLAG_ALLCONSIST (DIR_FLAG_CONSIST|DIR_FLAG_HASCONTENTS|DIR_FLAG_HASHEADERS|DIR_FLAG_HASDOTROOT|DIR_FLAG_HASINFO)

#define CHILD_FLAG_ISDOTLINK 1

typedef struct TChildNode *pChildNode;
struct TChildNode {
  fhandle Handle;
  char *Name;
  pChildNode Next;
  int Flags;
};

typedef struct TDirNode *pDirNode;
struct TDirNode {
  Hash_Entry *HashEntry;
  pChildNode Parent, Self; // these are also linked into HardLinks
  pChildNode HardLinks;
  pChildNode SymLinks;
  pDirNode Next;
  int Flags;
};

pChildNode DirAddChildToList(pChildNode *list, char *name, fhandle childhandle);
void DirAddChild(fhandle parent, fhandle childhandle, char *name, int symbolic);
int DirLookup(fhandle parent, char *name, fhandle dest);
int DirMakeConsist(fhandle parent);
int DirRead(fhandle parent, int start, pentry *first);
void DirSetParent(fhandle hdir, fhandle hparent, char *name);

#endif
