#ifndef HANDLE_H
#define HANDLE_H

#define INODE_DONTCARE -1

#ifdef WINDOWS
#include "nfsfake.h"
#else
#include "nfs.h"
#endif

#define METHOD_FALLBACK 0
#define METHOD_LZW 1
#define METHOD_HUFF 2
#define METHOD_LZHUFF 3
#define METHOD_COPY 4

#define GET_URL_METHOD(x) (((*(x)) >> 5)&0x7)
#define SET_URL_METHOD(x,y) (*(x)) = ((*(x)) & (0x1F)) | ((y)<<5)

#define GET_HSET_METHOD(x) (((*(x)) >> 3) & (0x3))
#define SET_HSET_METHOD(x,y) (*(x)) = ((*(x)) & (0xE7)) | ((y)<<3)
                                      
#define SET_TYPE(x,y) *(x)=((*(x)&0xF8)) | ((y)&0x7)
#define GET_TYPE(x) ((*(x))&0x7)

#define FLAG_HARDLINK 0
#define FLAG_SYMLINK 1
#define FLAG_CONTENTS 2
#define FLAG_HEADERS 3
#define FLAG_ROOT 4
#define FLAG_HEADERSET 5
#define FLAG_GENERATOR 6
#define FLAG_INFO 7

#define HANDLE_SKIP 5
#define HANDLE_OVERHEAD 9

#define ROOTNAME "http://"
#define ROOTINODE 1

void UrlToHandle(char *url, int inode, char *handle, int length, char **metadataptr);
int HandleToUrl(char *handle, int length, char **url, int *inode, char **metaptr);
int HandleToInode(char *handle, int length, int *inode);
void InodeToHandle(char *handle, int length, int inode);
int HandleGetType(char *handle);
void HandleSetType(char *handle, int htype);
void HandleCopy(fhandle dest, fhandle src);
void ShowHandle(FILE *fout, fhandle h);
void HandleInitFileType(char *handle, char *name);
int HandleGetNewInode(void);
int HandleToHeaders(fhandle handle, int length, char *metaptr, char **dest);
void HeadersToHandle(char *headers, char *handle, int length, char *metadataptr);
void HandleGetInfo(fhandle handle, int length, char *buffer, int *len);

extern int InodeCounter;
extern char *UrlMethodNames[];
extern int UrlMethodCounts[];

#endif
