#ifndef _HTTPCON_H
#define _HTTPCON_H

#define ERR_REQUEST_TOOLONG -1
#define ERR_REQUEST_NOSOCKET -2
#define ERR_REQUEST_CANTSENDGET -3
#define ERR_REQUEST_CANTSENDHEADER -4
#define ERR_REQUEST_BADMETHOD -5

#define MAX_HTTP_HEADERS 16
#define HTTP_HEADERS_BYTES 8192

#define HTTP_STATE_HEADERS 0
#define HTTP_STATE_DONE 1
#define HTTP_STATE_DATA 2

#define MAX_URL_LEN 1024

#ifndef WINDOWS
#ifndef HTTPCON_ST
#define HTTPCON_MUTEX
#include "thread.h"
#endif
#endif

struct HttpHeaders {
  char *Tag[MAX_HTTP_HEADERS];
  char *Data[MAX_HTTP_HEADERS];
  char Buf[HTTP_HEADERS_BYTES];
  int Count;
  char *BufPtr;
  int BufCount;

  int ResponseCode;
  int ByteCount;
};

#ifdef __CPLUSPLUS__
extern "C" {
#endif

SOCKET InitHttpSocket(char *servername, int port);
void InitHttpHeaders(struct HttpHeaders *h);
int GetHttpHeaders(struct Buffer *buf, int state, struct HttpHeaders *hdrin);

//int RequestUrl(char *server, int port, char *url, char *outfn, struct tnode **htmlroot);
int RequestUrlLow(char *proxyname,
               int proxyport,
               char *urlin,
               char *outfn,
               struct tnode **htmlroot,
               char *hdrout,
               struct HttpHeaders *hdrin,
               struct Buffer *buf,
               int timeout);
int RequestUrl(char *proxyname,
               int proxyport,
               char *urlin,
               char *outfn,
               struct tnode **htmlroot,
               char *hdrout,
               struct HttpHeaders *hdrin,
               struct Buffer *buf,
               int timeout,
               int redirlimit);
int GetChar(struct Buffer *buf);
SOCKET InitHttpSocket(char *servername, int port);

extern int HttpconAllowShutdown;
extern int HttpconOnlySaveGoodFiles;
extern int HttpconParseLinks;
int open_and_makedir(char *name, int mode, int attr);

#ifdef HTTPCON_MUTEX
extern MUTEX_TYPE MutexSocket;
#endif

#ifdef __CPLUSPLUS__
}
#endif

#endif
