typedef struct tree_node {
    unsigned int count;
    unsigned int saved_count;
    int child_0;
    int child_1;
} NODE;

typedef struct code {
    unsigned int code;
    int code_bits;
} CODE;

struct THuffTree {
  unsigned long *counts;
  NODE *nodes;
  CODE *codes;
  int root_node;
};

struct THuffParams {
/*  unsigned long *counts;
  NODE *nodes;
  CODE *codes;
  int root_node;
*/
  struct THuffTree* Trees;

  int numtrees;
  int numcodes;
  int END_OF_STREAM;
  int f13;
  int terminator;
  int bits;
  int scale;
  int NodesSize;
  int CodesSize;
};

int HuffmanCompressString(char *input, char *output, struct THuffParams *p);
int HuffmanExpandString(char *input, char *output, struct THuffParams *p, int *bread);
void HuffmanConfigure(struct THuffParams *p, char *input);
void HuffmanInit(struct THuffParams *p, int numcodes, int terminator, int bits, int trees);
void count_bytes(BIT_FILE *input, struct THuffParams *p);
void scale_counts(struct THuffParams *p, int treenum);
int build_tree(struct THuffParams *p, int treenum);
void convert_tree_to_code(struct THuffParams *p, unsigned int code_so_far, int bits, int node, int treenum);
void compress_data(BIT_FILE *input, BIT_FILE *output, struct THuffParams *p);
void expand_data(BIT_FILE *input, BIT_FILE *output, struct THuffParams *p);

