/*
 * List_Destroy.c --
 *
 *      Source code for the List_Destroy library procedure.
 *
 * @COPYRIGHT@
 */

static char rcsid[] = "$Id: List_Destroy.c,v 1.1.1.1 1999/08/27 17:42:50 bakers Exp $";

#include "list.h"

/*
 * List_Destroy --
 *
 *      Destroy a list given a pointer to its header and a deallocation
 *      procedure.
 *
 * Results:
 *      None.
 *
 * Side effects:
 *      The list is destroyed.
 */

void
List_Destroy (headerPtr, deallocator)
    List_Links *headerPtr;
    List_ElementDeallocator deallocator;
{
    List_Links *itemPtr;

    while (!List_IsEmpty (headerPtr)) {
        itemPtr = List_First (headerPtr);
        List_Remove (itemPtr);
        deallocator (itemPtr);
    }
}
