#include "stdinc.h"
#include <rpc/rpc.h>
#include <errno.h>
#include "thread.h"
#include "myrun.h"
#include "servmain.h"

int TimeIndex(void)
{
  struct timeval tv;

  gettimeofday(&tv,NULL);

  return ((tv.tv_sec%1000)*1000)+(tv.tv_usec/1000);
}

static void select_interrupt(int signo)
{
  return;
}

void my_svc_run(SOCKET httpsock)
{
#ifdef FD_SETSIZE
	fd_set readfds;
#else
      int readfds;
#endif /* def FD_SETSIZE */
        int count;
        struct timeval tv;
        int the_error;

	for (;;) {
          int n = _rpc_dtablesize();
#ifdef FD_SETSIZE
		readfds = svc_fdset;
#else
		readfds = svc_fds;
#endif /* def FD_SETSIZE */
                if (httpsock!=INVALID_SOCKET) {
                  FD_SET(httpsock,&readfds);
                  if (n<httpsock+1)
                    n=httpsock+1;
                }

//                printf("%d: calling select\n",TimeIndex());
		tv.tv_sec=1;
                tv.tv_usec=0;
                MainThreadInSelect=TRUE;
                MUTEX_UNLOCK(MutexRPC);
 		count = select(n, &readfds, (fd_set *)0, (fd_set *)0, (struct timeval *) &tv);
                MUTEX_LOCK(MutexRPC);
                MainThreadInSelect=FALSE;
//                printf("%d: done select, count=%d\n",TimeIndex(),count);
		switch (count) {
		case -1:
/*			if (errno == EINTR) {
                        	printf("EINTR\n");
                                ProcessRPCReplies();
				continue;
			}
			perror("svc_run: - select failed");
			return;*/
                        /* something is dreadfully wrong here! */
                        continue;
		case 0:
			continue;
		default:
                        if ((httpsock!=INVALID_SOCKET) && (FD_ISSET(httpsock,&readfds))) {
                          HandleHttpRequest(httpsock);
                          count--;
                          FD_CLR(httpsock,&readfds);
                        }
                        if (count>0)
    			  svc_getreqset(&readfds);
		}
	}
}
