#ifndef NFSFAKE_H
#define NFSFAKE_H

#define FHSIZE 32
typedef char fhandle[FHSIZE];

typedef char *filename;
typedef char nfscookie[4];

typedef struct entry *pentry;

struct entry {
        u_int fileid;
        filename name;
        nfscookie cookie;
        pentry nextentry;
};
typedef struct entry entry;

struct nfstimeval {
        u_int seconds;
        u_int useconds;
};
typedef struct nfstimeval nfstimeval;


enum ftype {
        NFNON = 0,
        NFREG = 1,
        NFDIR = 2,
        NFBLK = 3,
        NFCHR = 4,
        NFLNK = 5,
};
typedef enum ftype ftype;


struct fattr {
        ftype type;
        u_int mode;
        u_int nlink;
        u_int uid;
        u_int gid;
        u_int size;
        u_int blocksize;
        u_int rdev;
        u_int blocks;
        u_int fsid;
        u_int fileid;
        nfstimeval atime;
        nfstimeval mtime;
        nfstimeval ctime;
};


#endif
