#include "stdinc.h"
#include "nfs.h"
//#include "server2.h"
#include "servmain.h"

void debug(char *msg, void*, void*);

/* ----------------- mount procedures that do nothing! ---------------- */

void *
mountproc_null_1(void *argp, struct svc_req *rqstp)
{
  char *result = (char*) AllocResult(4);

  debug("null",NULL,NULL);

  *result = '\0';
  return((void*) result);
}

mountlist *
mountproc_dump_1(void *argp, struct svc_req *rqstp)
{
  mountlist *result = (mountlist*) AllocResult(sizeof(mountlist));

  debug("dump",NULL,NULL);

  memset(result,0,sizeof(mountlist));

  return(result);
}

void *
mountproc_umnt_1(dirpath *argp, struct svc_req *rqstp)
{
  char *result = (char*) AllocResult(4);

  debug("umnt",*argp,NULL);

  *result='\0';
  return((void*) result);
}

void *
mountproc_umntall_1(void *argp, struct svc_req *rqstp)
{
  char *result = (char*) AllocResult(4);

  debug("umntall",NULL,NULL);

  *result='\0';
  return((void*) result);
}

/* ----------------- nfs procedures that do nothing! ------------------ */

void *
nfsproc_null_2(void *argp, struct svc_req *rqstp)
{
  char *result = (char*) AllocResult(4);

  debug("nfs_null",NULL,NULL);

  *result='\0';
  return((void*) result);
}

/*
readlinkres *
nfsproc_readlink_2(fhandleargs *argp, struct svc_req *rqstp)
{
  readlinkres *result = (readlinkres*) AllocResult(sizeof(readlinkres));

  debug("nfs_readlink",NULL,NULL);

  memset(result,0,sizeof(readlinkres));
  return(result);
}
*/

void *
nfsproc_writecache_2(void *argp, struct svc_req *rqstp)
{
  char *result = (char*) AllocResult(4);

  debug("nfs_writecache",NULL,NULL);

  *result = '\0';
  return((void*) result);
}

/*attrstat *
nfsproc_write_2(writeargs *argp, struct svc_req *rqstp)
{
  attrstat *result = (attrstat*) AllocResult(sizeof(attrstat));

  debug("nfs_write",NULL,NULL);

  memset(result,0,sizeof(attrstat));
  return(result);
} */

/*diropres *
nfsproc_create_2(createargs *argp, struct svc_req *rqstp)
{
  diropres *result = (diropres*) AllocResult(sizeof(diropres));

  debug("nfs_create",NULL,NULL);

  memset(result,0,sizeof(diropres));
  return(result);
}*/


/*nfsstat *
nfsproc_remove_2(diropargs *argp, struct svc_req *rqstp)
{
  nfsstat *result = (nfsstat*) AllocResult(sizeof(nfsstat));

  debug("nfs_remove",NULL,NULL);

  memset(result,0,sizeof(nfsstat));
  return(result);
} */


nfsstat *
nfsproc_rename_2(renameargs *argp, struct svc_req *rqstp)
{
  nfsstat *result = (nfsstat*) AllocResult(sizeof(nfsstat));

  debug("nfs_rename",NULL,NULL);

  memset(result,0,sizeof(nfsstat));
  return(result);
}

nfsstat *
nfsproc_link_2(linkargs *argp, struct svc_req *rqstp)
{
  nfsstat *result = (nfsstat*) AllocResult(sizeof(nfsstat));

  debug("nfs_link",NULL,NULL);

  memset(result,0,sizeof(nfsstat));
  return(result);
}

nfsstat *
nfsproc_symlink_2(symlinkargs *argp, struct svc_req *rqstp)
{
  nfsstat *result = (nfsstat*) AllocResult(sizeof(nfsstat));

  debug("nfs_symlink",NULL,NULL);

  memset(result,0,sizeof(nfsstat));
  return(result);
}

/*diropres *
nfsproc_mkdir_2(createargs *argp, struct svc_req *rqstp)
{
  diropres *result = (diropres*) AllocResult(sizeof(diropres));

  debug("nfs_mkdir",NULL,NULL);

  memset(result,0,sizeof(diropres));
  return(result);
}*/


nfsstat *
nfsproc_rmdir_2(diropargs *argp, struct svc_req *rqstp)
{
  nfsstat *result = (nfsstat*) AllocResult(sizeof(nfsstat));

  debug("nfs_rmdir",NULL,NULL);

  memset(result,0,sizeof(nfsstat));

  *result = NFSERR_NOTDIR;

  return(result);
}


/*attrstat *
nfsproc_setattr_2(sattrargs *argp, struct svc_req *rqstp)
{
  attrstat *result = (attrstat*) AllocResult(sizeof(attrstat));

  debug("nfs_setattr",NULL,NULL);

  memset(result,0,sizeof(attrstat));
  return(result);
}*/

void *
nfsproc_root_2(void *argp, struct svc_req *rqstp)
{
  char *result = (char*) AllocResult(4);

  debug("nfs_root",NULL,NULL);

  *result = '\0';
  return((void*) result);
}