// note that the statistics system does not allocate string space and matches
// it's records based on pointer comparisons rather than strcmp() calls for
// speed. So always use the same pointer for the same statistic measurement.


#define MAX_STAT_DEPTH 16
#define MAX_STAT_COUNT 256

#define MAX_STAT_ELAPSED 250
#define MULTIPLIER 50
#define STAT_COUNT_LIMIT 2000

#ifdef WINDOWS
#define pid_t int
#endif

typedef struct StatRecord *pStatRecord;

typedef struct StatInfo *pStatInfo;

struct StatInfo {
  int DispCount;
  pid_t Pid;
  char *Names[MAX_STAT_DEPTH];
  TIMESTAMP Times[MAX_STAT_DEPTH];
  int Depth;
  int Index;
};

struct StatRecord {
  char *Name;
  int Total;
  int TotalTime;
  int HistoSmall[MAX_STAT_ELAPSED];
  int HistoBig[MAX_STAT_ELAPSED];
  pStatRecord Next;
};

void InitStatistics();
void RecordStatistics(char *name, pStatInfo statinfo);
pStatInfo StartStatistics(char *name);
void DumpStatistics();
void StatShowURL(char *x);

