#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <time.h>

#ifdef WINDOWS
#include <io.h>
#include <windows.h>
#include <winsock.h>

#define ADDRTYPE unsigned long
#define INET_ADDR_FAIL INADDR_NONE
#else

#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <rpc/rpc.h>
#include <netinet/in.h>

typedef int SOCKET;

#define ADDRTYPE unsigned int
//#define ADDRTYPE __u32

#define closesocket(x) close(x)
#define INVALID_SOCKET -1
#define SOCKET_ERROR -1
#define INET_ADDR_FAIL -1

#endif

#ifndef TRUE
#define TRUE 1
#define FALSE (!TRUE)
#endif

#ifndef O_BINARY
#define O_BINARY 0
#endif

#define MAX_PATH_LEN 260

#ifdef WINDOWS
typedef int TIMESTAMP;
typedef int T_TIMESTAMP;
#define SET_TIMESTAMP(x) (x)=GetTickCount()
#define GET_ELAPSED(start,end) (abs((end)-(start)))
#define SLEEP(x) Sleep((x)*1000);
#else
typedef struct timeval TIMESTAMP;
typedef struct timeval T_TIMESTAMP;
#define SET_TIMESTAMP(x) gettimeofday(&(x),NULL)
#define GET_ELAPSED(start,finish) (abs((((finish).tv_sec-(start).tv_sec)*1000000L+((finish.tv_usec)-(start.tv_usec)))/1000))
#define GET_ELAPSED10(start,finish) (abs((((finish).tv_sec-(start).tv_sec)*1000000L+((finish.tv_usec)-(start.tv_usec)))/100))
#define GET_ELAPSED100(start,finish) (abs((((finish).tv_sec-(start).tv_sec)*1000000L+((finish.tv_usec)-(start.tv_usec)))/10))
#define SLEEP(x) sleep(x);

#define stricmp(x,y) strcasecmp(x,y)
#define strnicmp(x,y,n) strncasecmp(x,y,n)
#endif

#ifndef MIN
#define MIN(x,y) ((x)<(y) ? (x) : (y))
#endif

#ifndef MAX
#define MAX(x,y) ((x)>(y) ? (x) : (y))
#endif

#define FORWARDSLASH '/'
#define BACKSLASH '\\'

#ifdef WINDOWS
#define SLASH BACKSLASH
#else
#define SLASH FORWARDSLASH
#endif
