#include "thread.h"

#ifndef NOTHREAD
#ifndef WINDOWS
#include "stdinc.h"

void sem_init(SEMAPHORE_TYPE *x)
{
  CREATE_MUTEX(x->Mutex);
  COND_INIT(x->Condition);
  x->Count = 0;
}

void sem_wait(SEMAPHORE_TYPE *x)
{
  MUTEX_LOCK(x->Mutex);
  while (x->Count==0)
    COND_WAIT(x->Condition,x->Mutex);

  x->Count-=1;

  MUTEX_UNLOCK(x->Mutex);
}

void sem_post(SEMAPHORE_TYPE *x)
{
  MUTEX_LOCK(x->Mutex);
  COND_SIGNAL(x->Condition);

  x->Count+=1;

  MUTEX_UNLOCK(x->Mutex);
}

#endif
#endif