#include "stdinc.h"
#include "url.h"

/*void PrintHex(char *dest, void *data, int len)
{
  char digits[16] = "0123456789abcdef";
  unsigned char *x = (unsigned char *) data;
  int i;

  for (i=0; i<len; i++) {
    *(dest++) = digits[(*x)>>4];
    *(dest++) = digits[(*x)&0xf];

    x++;
  }

  *dest='\0';
}

int ReadHex(void *dest, char *s)
{
  unsigned char *d = (unsigned char *) dest;
  int val;
  int len = 0;
  char s2[256];

  while ((*s) && (*(s+1)) && ((len++)<8)) {
    unsigned char c = (unsigned char) tolower(*s);
    unsigned char c2 = (unsigned char) tolower(*(s+1));

    if ((c>='0') && (c<='9'))
      val=(c-'0');
    else if ((c>='a') && (c<='f'))
      val=(c-'a')+10;

    val<<4;

    if ((c2>='0') && (c2<='9'))
      val+=(c2-'0');
    else if ((c2>='a') && (c2<='f'))
      val+=(c2-'a')+10;

    *(d++) = s;
    s+=2;
  }

  PrintHex(s2,dest,4);
  printf("*** %s %s\n",s,s2);

  return (int) val;
}*/

void AddSlash(char *s)
{
  char *last = (s+strlen(s)-1);

  if (*last!=SLASH) {
    *(last+1)=SLASH;
    *(last+2)='\0';
  }
}

void TruncateAtFirstCharacter(char *req, char ch)
{
  char *x;

  for (x = req; *x; x++)
    if (*x==ch) {
      *x='\0';
      return;
    }
}

int ParseName(char *req, char *host, int *port, char *url)
{
  *host = '\0';
  *port = 80;
  strcpy(url,"/");

  if (strnicmp(req,"http://",7)==0) {
    char *hoststart = req+7;
    char *urlstart = strchr(hoststart,'/');
    char *colon;

    if (urlstart!=NULL) {
      *urlstart='\0';
      strcpy(host,hoststart);
      *urlstart='/';
      strcpy(url,urlstart);
    } else
      strcpy(host,hoststart);

    colon = strchr(host,':');
    if (colon!=NULL) {
      *colon = '\0';
      (*port) = atoi(colon+1);
    }

    return TRUE;
  } else {
    strcpy(url,req);
    return FALSE;
  }
}

int IsHtml(char *s)
{
  char *dotpos = strrchr(s,'.');

  if (dotpos==NULL)
    return FALSE;

  return ((tolower(*(dotpos+1))=='h') &&
         (tolower(*(dotpos+2))=='t') &&
         (tolower(*(dotpos+3))=='m'));
}

void AppendHostName(char *dest, char *url)
{
  char *seppos = strstr(url,"://");
  char *slashpos;

  if (seppos==NULL)
    return;

  seppos+=3;
  slashpos = strchr(seppos,'/');

  if (slashpos!=NULL)
    *slashpos='\0';

  strcat(dest,seppos);

  if (slashpos!=NULL)
    *slashpos='/';
}

void BuildUrl(char *dest, char *srcdoc, char *url)
{
  char *colonpos;

  colonpos = strchr(url,':');
  if (colonpos!=NULL) {
    *colonpos = '\0';

    if (stricmp(url,"http")!=0) {
      *colonpos = ':';
      strcpy(dest,url);
      return;
    }

    *colonpos = ':';
    url = colonpos+1;
  }

  if (strncmp(url,"//",2)==0) {
    strcpy(dest,"http:");
    strcat(dest,url);
    return;
  } else if (*url=='/') {
    strcpy(dest,"http://");
    AppendHostName(dest,srcdoc);
    strcat(dest,url);
  } else {
    char *slashpos;
    strcpy(dest,srcdoc);

    slashpos = strrchr(dest,'/');
    if (slashpos!=NULL)
      *(slashpos+1)='\0';

    strcat(dest,url);
  }
}

void CollapseDotDot(char *x)
{
  char build[512];
  char *slashpos, *dotpos;

  strcpy(build,x);
  while ((dotpos=strstr(build,"/../"))!=NULL) {
    *dotpos='\0';
    slashpos = strrchr(build,'/');

    /* can't collapse any further -- return */
    if (slashpos==NULL)
      return;

    *slashpos = '\0';
    strcpy(x,build);
    strcat(x,dotpos+3);

    strcpy(build,x);
  }
}

static struct {char *name; char map;} EscapeMap[] = {
  {"&quot;",    '"'},
  {"&amp;",     '&'},
  {"&lt;",      '<'},
  {"&gt;",      '>'},
  {NULL,        '\0'}};

char ResolveEscape(char *src)
{
  int f;

  for (f=0; EscapeMap[f].name!=NULL; f++)
    if (strnicmp(EscapeMap[f].name,src,strlen(EscapeMap[f].name))==0)
      return EscapeMap[f].map;

  return '\0';
}

void TranslateEscape(char *dest, char *src)
{
  char *colonpos;
  char ch;

  // the simple case -- no escape sequences
  if ((strchr(src,'&')==NULL) || (strchr(src,';')==NULL)) {
    strcpy(dest,src);
    return;
  }

  while (*src) {
    if ((*src=='&') && ((colonpos=strchr(src,';'))!=NULL) && ((ch=ResolveEscape(src))!='\0')) {
      *(dest++) = ch;
      src=colonpos;
    } else
      *(dest++) = *src;

    src++;
  }

  *dest='\0';
}

int NormalizeUrlFromUrl(char *base, char *url, char *linkbuf_out, int preserve_terminating_slash)
{
  int dotdotcount;
  char *poundpos, *last, *slashpos;
  char *colonpos;
  char *x;
  char linkbuf[1024];

  *linkbuf = '\0';
  *linkbuf_out = '\0';

  if ((strlen(base)+strlen(url)+16)>sizeof(linkbuf))
    return FALSE;

  // find the ':' that would be in http:
  colonpos = strchr(url,':');

  // make sure only alpha-num characters preceed the colon
  if (colonpos!=NULL)
    for (x=url; ((x!=colonpos) && (colonpos!=NULL)); x++)
      if (!isalnum(*x))
        colonpos=NULL;

  // no we have some alphanum digits followed by a colon, must be a protocol
  // method specified (http:, ftp:, etc). Exit w/ FALSE if it's not http:,
  // else remove it.
  if (colonpos!=NULL) {
    *colonpos = '\0';

    if (stricmp(url,"http")!=0) {
      *colonpos = ':';
      return FALSE;
    }

    *colonpos = ':';
    url = colonpos+1;
  }

  if (strncmp(url,"//",2)==0) {
    /* absolute path with hostname: //host/dir/.../file */
    sprintf(linkbuf,"http:%s",url);
  } else if (*url=='/') {
    if (base==NULL)
      return FALSE;

    /* absolute path within the current host /dir/.../file */

    strcpy(linkbuf,"http://");
    GetHostNameFromUrl(linkbuf+7,base);
    strcat(linkbuf,url);
  } else {
    /* relative path within the current host .../file */

    if (base==NULL)
      return FALSE; /* can't have a relative path from no file! */

    dotdotcount=0;

    /* count up any '..' directories so we can remove them */
    while (strncmp(url,"../",3)==0) {
      url+=3;
      dotdotcount++;
    }

    dotdotcount++; /* remove the last path component automatically */
    strcpy(linkbuf,base);

    while ((dotdotcount>0) && ((slashpos=strrchr(linkbuf+7,'/'))!=NULL)) {
      dotdotcount--;
      *slashpos='\0';
    }

    strcat(linkbuf,"/");
    strcat(linkbuf,url);
  }

  /* nuke any anchor tag specifier */
  poundpos = strchr(linkbuf,'#');
  if (poundpos!=NULL)
    *poundpos='\0';

  /* get rid of any terminating slash characters */
  if (!preserve_terminating_slash) {
    last = linkbuf+strlen(linkbuf)-1;
    while ((last>=linkbuf) && (*last=='/')) {
      *last = '\0';
      last--;
    }
  }

  TranslateEscape(linkbuf_out,linkbuf);

  return TRUE;
}

void GetHostNameFromUrl(char *dest, char *url)
{
  char *slashslash = strstr(url,"//");
  char *slash;

  if (slashslash!=NULL)
    url=slashslash+2;

  strcpy(dest,url);
  slash = strchr(dest,'/');

  if (slash!=NULL)
    *slash='\0';
}

// compare two URL's for equality (also works for two hostnames)
// test with and without the www part
// www1=www2=www, etc
int EqualHostName(char *u1, char *u2)
{
  char h1[1024], h2[1024];
  char *ph1=h1,*ph2=h2;

  GetHostNameFromUrl(h1,u1);
  GetHostNameFromUrl(h2,u2);

  // check the plain hostnames
  if (stricmp(h1,h2)==0)
    return TRUE;

  // see what happens if we strip off the www part
  if ((strnicmp(ph1,"www",3)==0) && (strchr(ph1,'.')!=NULL))
    ph1=strchr(ph1,'.')+1;

  if ((strnicmp(ph2,"www",3)==0) && (strchr(ph2,'.')!=NULL))
    ph2=strchr(ph2,'.')+1;

  if (stricmp(ph1,ph2)==0)
    return TRUE;

  return FALSE;
}

int CheckForwardURL(char *n1, char *n2)
{
  char *slash = strrchr(n1,'/');
  int len;

  if (slash==NULL)
    return FALSE;

  len = (slash-n1);

  if (strnicmp(n1,n2,len)==0)
    return TRUE;

  return FALSE;
}




